//
// Institute for Signal Processing (University of Luebeck, Germany)
// Copyright (c) 2010 by Florian Mueller
//
// Permission to use, copy, modify, and distribute this software without
// fee is hereby granted FOR RESEARCH/EDUCATION PURPOSES only, provided
// that this copyright notice appears in all copies and in all supporting
// documentation, and that the software is not redistributed for any
// fee (except for a nominal shipping charge).
//
// For any other uses of this software, in original or modified form,
// including but not limited to consulting, production or distribution
// in whole or in part, specific prior permission must be obtained
// from the author.
// Signal processing methods and algorithms implemented by this
// software may be claimed by patents owned by others.
//
// The author makes no representation about the suitability of this
// software for any purpose. It is provided "as is" without warranty
// of any kind, either expressed or implied.
// Beware of the bugs.
//
//     Revision history
//
//     Ver     Date         Description
//     -------------------------------------------------------------------
//     0.9     01-05-2010   basic version 
//     0.9.2   01-07-2010   Recoded in C++ with OOP approach
//

#ifndef CONSOLEHELPERS_H
#define CONSOLEHELPERS_H
#include <vector>
#include <iostream>
#include <sstream>
#include <fstream>
#include <cstdlib>
#include <string.h>

typedef std::vector<double> dVec;
typedef std::vector<int> iVec;



class ConsoleHelpers
{

public:
    ConsoleHelpers(void);
    void readConsoleParameters(int argc, char **);
    // unsigned long int endian_swap(unsigned long int&);
    bool   calcGFB;                 // flag, if set: calculate gammatone filterbank
    bool   calcIIF;                 // flag, if set: calculate IIF
    bool   useCF;                   // flag, if set: use given center frequencys
    double compression;             // compression factor
    double samplerate;              // samplerate [Hz]
    double freqmin;                 // minimum frequency [Hz]
    double freqmax;                 // maximum frequency [Hz]
    double nfilter;                 // number of filters
    double frameshift;              // frame shift [ms]
    double framesize;               // frame size [ms]
    double width;                   // scaling factor for relative-bandwidth
    double preemphasize;
    bool meannorm;
    bool stdnorm;
    bool DOZEROPAD;
    std::string CFfile;                  // filename (Center frequency containing file)
    std::string inputfile;
    std::string outputfile;
    std::string configfile;
    unsigned short endian_swap(unsigned short&);
    virtual ~ConsoleHelpers();
    private:
    void help();

};


#endif // GAMMATONEFB_H
