//
// Institute for Signal Processing (University of Luebeck, Germany)
// Copyright (c) 2010 by Florian Mueller
//
// Permission to use, copy, modify, and distribute this software without
// fee is hereby granted FOR RESEARCH/EDUCATION PURPOSES only, provided
// that this copyright notice appears in all copies and in all supporting
// documentation, and that the software is not redistributed for any
// fee (except for a nominal shipping charge).
//
// For any other uses of this software, in original or modified form,
// including but not limited to consulting, production or distribution
// in whole or in part, specific prior permission must be obtained
// from the author.
// Signal processing methods and algorithms implemented by this
// software may be claimed by patents owned by others.
//
// The author makes no representation about the suitability of this
// software for any purpose. It is provided "as is" without warranty
// of any kind, either expressed or implied.
// Beware of the bugs.
//
//     Revision history
//
//     Ver     Date         Description
//     -------------------------------------------------------------------
//     0.9     01-05-2010   basic version 
//     0.9.2   01-07-2010   Recoded in C++ with OOP approach
//

#ifndef IIFCOMPUTATION_H_INCLUDED
#define IIFCOMPUTATION_H_INCLUDED
#include <vector>
#include <iostream>
#include <sstream>
#include <fstream>
#include <cmath>
#include <cstdlib>
#include <complex>
#include <cmath>
#include <string.h>
#include"array2d.h"
typedef std::vector<double> dVec;
typedef std::vector<int> iVec;
typedef std::complex<double> cDouble;
typedef std::vector<cDouble> cVec;

class IIFcomputation
{
    public:
       Array2d<double> computeIIFs(Array2d<double>, bool, bool, bool);
       void readConfigFile(std::string filename);
       IIFcomputation();
        virtual ~IIFcomputation();
    private:
        Array2d<int> configData;
        void getNumberConfigFiles();
        std::string configfile;
        void getConfigSize(std::string);
        int maxConfigLines;
        int ConfigLines;
        int maxConfigNumber;
        iVec NumbersInLine;
        iVec validConfigLines;
        Array2d<double> subductMean(Array2d<double>, bool, bool );

};


#endif // IIFCOMPUTATION_H_INCLUDED

